var fontEnumerator = null;

function onPrefsLoad() {
  var count = { value: 0 }
  var fonts = getFontEnumerator().EnumerateAllFonts(count);
  var fontList = document.getElementById("fontpicker").firstChild;
  for (var font in fonts) {
    font = fonts[font];
    var itemNode = document.createElement("menuitem");
    itemNode.setAttribute("value", font);
    itemNode.setAttribute("label", font);
    fontList.appendChild(itemNode);
  }
  document.getElementById("fontpicker").value = prefBranch.getCharPref("font.name");
  document.getElementById("foregroundtextmenu").color = prefBranch.getCharPref("font.color");
  document.getElementById("chkBold").checked = prefBranch.getBoolPref("font.bold");
  document.getElementById("chkItalic").checked = prefBranch.getBoolPref("font.italic");
  document.getElementById("chkUnderline").checked = prefBranch.getBoolPref("font.underline");
  document.getElementById("chkStrike").checked = prefBranch.getBoolPref("font.strike");
}

function doOK() {
  prefBranch.setCharPref("font.name", window.document.getElementById("fontpicker").value);
  prefBranch.setBoolPref("font.bold", window.document.getElementById("chkBold").checked);
  prefBranch.setBoolPref("font.italic", window.document.getElementById("chkItalic").checked);
  prefBranch.setBoolPref("font.underline", window.document.getElementById("chkUnderline").checked);
  prefBranch.setBoolPref("font.strike", window.document.getElementById("chkStrike").checked);
  prefBranch.setCharPref("font.color", window.document.getElementById("foregroundtextmenu").color);
}

function getFontEnumerator() {
  if (fontEnumerator == null) {
    fontEnumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"].createInstance()
                       .QueryInterface(Components.interfaces.nsIFontEnumerator);
  }
  return fontEnumerator;
}